// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UBlackboardKeyType.h"
#include "ISCW_UEnum.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{	
	class ISCW_UBlackboardKeyType_Enum : public virtual ISCW_UBlackboardKeyType
	{
	public:
		virtual ~ISCW_UBlackboardKeyType_Enum() = default;
		
		virtual shared_ptr<ISCW_UBlackboardKeyType_Enum> ToUBlackboardKeyType_EnumPtr() = 0;
		virtual shared_ptr<const ISCW_UBlackboardKeyType_Enum> ToUBlackboardKeyType_EnumPtr() const = 0;

		virtual wstring GetEnumName() const = 0;

		virtual void SetEnumName(const wstring& EnumName) = 0;

		virtual ISCW_UEnumPtr GetEnumType() const = 0;

		virtual void SetEnumType(ISCW_UEnumPtr EnumType) = 0;
	};

	using ISCW_UBlackboardKeyType_EnumConstPtr = shared_ptr<const ISCW_UBlackboardKeyType_Enum>;
	using ISCW_UBlackboardKeyType_EnumPtr = shared_ptr<ISCW_UBlackboardKeyType_Enum>;
} // namespace Sourcify